
const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");

let v,dv, av, f1,f2,q,l, r1,r2,a,b,a1,b1;
	
//let buffer = null;
let d = { width: canvas.width, height: canvas.height };

function init() {
		v=0;
		f1=1;f2=0;
        q=0;
		av=6;	
		dv=av;
		l=5*d.height/6;
        r1=15;
        r2=15;
        a=1;b=1;a1=0;b1=1;
        buffer = createBuffer(d.width, d.height);
        drawToBuffer();
}

function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
	const g = buffer.getContext("2d");
    g.fillStyle = "white";
    g.fillRect(0, 25, d.width, d.height -25);
	
	g.strokeStyle = "black";
    g.beginPath();
    g.moveTo(d.width/2-r1,35);
    g.lineTo(d.width/2-r1-l*Math.sin(Math.cos(2*Math.PI*v/360)*a/2),
           35+l*Math.cos(Math.cos(2*Math.PI*v/360)*a/2));
	g.stroke();	   
	
	g.strokeStyle = "black";
    g.beginPath();
    g.moveTo(d.width/2+r2,35);
    g.lineTo(d.width/2+r2+l*Math.sin(f2*Math.cos(2*Math.PI*v/360)*b/2),
           35+l*Math.cos(f2*Math.cos(2*Math.PI*v/360)*b/2));
	g.stroke();	 
	
	g.fillStyle = "red";
	g.beginPath();
        g.arc(d.width/2+r2+
           l*Math.sin(f2*Math.cos(2*Math.PI*v/360)*b/2),
       35+l*Math.cos(f2*Math.cos(2*Math.PI*v/360)*b/2), r2, 0, Math.PI * 2);
    g.fill();	

    g.fillStyle = "blue";
	g.beginPath();
        g.arc(d.width/2-r1-l*Math.sin(Math.cos(2*Math.PI*v/360)*a/2), 
		35+l*Math.cos(Math.cos(2*Math.PI*v/360)*a/2), r1, 0, Math.PI * 2);
    g.fill();
	
	g.fillStyle = "gray";
    g.fillRect(0,20,d.width,15);
	

		   
}

function move() {
        dv=q*av;
		v=v+dv;
        if (Math.cos(2*3.14159*v/360)>0){
           f2=0;
           a=1;
           b=1;
		}
		if (Math.cos(2*3.14159*v/360)<0){
           f2=1;
           a=a1;
           b=-b1;
		}
}

function start() {
    setInterval(function() {
        move();
        drawToBuffer();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }, 30);
}

document.getElementById('Reset').addEventListener('click', Reset);
document.getElementById('mM1').addEventListener('click', mM1);
document.getElementById('mM2').addEventListener('click', mM2);
document.getElementById('mM3').addEventListener('click', mM3);
document.getElementById('earth').addEventListener('click', earth);
document.getElementById('moon').addEventListener('click', moon);
document.getElementById('startButton').addEventListener('click', startButton);



function Reset() {
         a=1;b=1;f2=0;av=6;v=0;//f1=1;
                r1=15;r2=15;q=0;a1=0;b1=1;
}
function mM1() {
         a=1;b=1;f2=0;v=0;
         r1=15;r2=15;q=0;
         a1=0;b1=1;
}
function mM2() {
        a=1;b=1;// f2=0;
        v=0;
        r1=10;r2=15;q=0;
        a1=-1/3;  b1=2/3;
}
function mM3() {
        f2=0;v=0;
        r1=15;r2=10;q=0;a1=0.333;b1=1.667;
}
function earth() {
        av=6;
}
function moon() {
        av=2;
}
function startButton() {
        q=1;
}


init();
start();




